﻿unit U_ExtImages;

interface

{$i ..\extends.inc}
{$IFDEF FPC}
{$Mode Delphi}
{$ENDIF}

uses
{$IFDEF VERSIONS}
  fonctions_version,
{$ENDIF}
  Classes, U_ExtMapImageIndex,
  U_ExtImage,
  u_framework_components,
  Controls,
{$IFDEF TNT}
     TntExtCtrls, TntStdCtrls,
{$ELSE}
     ExtCtrls, StdCtrls,
{$ENDIF}
     u_extcomponent;

const
  CST_DEFAULT_PANEL_WIDTH = 150;
  CST_DEFAULT_PANEL_HEIGHT = 100;
{$IFDEF VERSIONS}
  gVer_TExtImages : T_Version = ( Component : 'Composant TExtImages' ;
                                  FileUnit : 'U_ExtImages' ;
                                  Owner : 'Matthieu Giroux' ;
                                  Comment : 'Présentation d''images de tous types avec résumé intégré dans le répertoire.' ;
                                  BugsStory : '0.9.0.0 : Creating from TExtImage.';
                                  UnitType : 3 ;
                                  Major : 0 ; Minor : 9 ; Release : 0 ; Build : 0 );

{$ENDIF}

type
  TExtPanelImage = class;
  TExtCollectionImages = class;

 { TExtMapImageIndex }

  { TExtPanelImage }

  TExtPanelImage = class(TExtMapImageIndex)
  private
    s_Path : String;
    FMemo  : {$IFDEF TNT}TTntMemo{$ELSE}TMemo{$ENDIF};
    FPanel : {$IFDEF TNT}TTntPanel{$ELSE}TPanel{$ENDIF};
    FImage : TExtImage;
    procedure SetMemo ( AValue : {$IFDEF TNT}TTntMemo{$ELSE}TMemo{$ENDIF} ); virtual;
    procedure SetPanel ( AValue : {$IFDEF TNT}TTntPanel{$ELSE}TPanel{$ENDIF} ); virtual;
    procedure SetImage ( AValue : TExtImage ); virtual;
  public
    constructor Create(ACollection: TCollection); override;
    destructor Destroy; override;
  published
    property Memo  : {$IFDEF TNT}TTntMemo{$ELSE}TMemo{$ENDIF} read FMemo write SetMemo;
    property Panel : {$IFDEF TNT}TTntPanel{$ELSE}TPanel{$ENDIF} read FPanel write SetPanel;
    property Image : TExtImage read FImage write SetImage;
  End;

  TExtPanelImageClass = class of TExtPanelImage;

 { TExtMapImagesColumns }
  TExtCollectionImages = class(TExtMapImagesColumns)
  private
  protected
  public
  End;

{ TExtImages }

   TExtImages = class( {$IFDEF TNT}TTntPanel{$ELSE}TPanel{$ENDIF}, IFWComponent )
     private
       FClickEdit,
       FSubDirs,
       FShowErrors:Boolean;
       FDirectory : String;
       FImagesFormat : Single ;
       FPanelWidth, FPanelHeight : Integer;
       FImagesColumns : TExtCollectionImages;
       procedure CreateImagesMap; virtual;
       procedure SetColumns ( AValue : TExtCollectionImages ); virtual;
       procedure AddDirectory(const as_Directory: String; ab_SubDirs: Boolean);
       procedure p_SetDirectory ( const as_value : String );
     protected
       procedure AddFile (  const as_SourceFile : String );
     public
       procedure Click;override;
       procedure ClickDoEdit;virtual;
       procedure RenameImage(const AOldPath, ANewPath : String ; const AnOptionalPanelImage : TExtPanelImage);virtual;
       procedure CreateResume(const As_PathOfImage, As_Resume : String );virtual;
       constructor Create(AOwner: TComponent); override;
       procedure Loaded; override;
     private

       function IndexOf ( const AValue : String ): Integer; virtual;
       function ImageIndexOf ( const AValue : String ): Integer; virtual;
     published
     { Published declarations }
       property Columns : TExtCollectionImages read FImagesColumns write SetColumns ;
       property Directory : String read FDirectory write p_SetDirectory ;
       property ShowErrors : Boolean read FShowErrors write FShowErrors default True ;
       property SubDirs : Boolean read FSubDirs write FSubDirs default True ;
       property ClickEdit : Boolean read FClickEdit write FClickEdit default True ;
       property ImagesFormat : Single read FImagesFormat write FImagesFormat;
       property PanelWidth  : Integer read FPanelWidth write FPanelWidth default CST_DEFAULT_PANEL_WIDTH;
       property PanelHeight : Integer read FPanelHeight write FPanelHeight default CST_DEFAULT_PANEL_HEIGHT;
     end;


implementation

uses fonctions_images,
{$IFDEF FPC}
     unite_messages,
     FileUtil,
{$ELSE}
      unite_messages_delphi,
      fonctions_system,
{$ENDIF}
     sysutils,
     fonctions_file,
     ExtDlgs;

{ TExtPanelImage }

procedure TExtPanelImage.SetMemo(AValue: TMemo);
begin
  FMemo.Assign(AValue);
end;

procedure TExtPanelImage.SetPanel(AValue: TPanel);
begin
  FPanel.Assign(AValue);

end;

procedure TExtPanelImage.SetImage(AValue: TExtImage);
begin
  FImage.Assign(AValue);

end;

constructor TExtPanelImage.Create(ACollection: TCollection);
begin
  inherited Create(ACollection);
  with ACollection as TExtMapImagesColumns do
   Begin
    FMemo  := TFWMemo.Create(Component);
    with FMemo do
      Begin
       Parent:=Component as TWinControl;
       Visible:=True;
      end;
    FPanel := {$IFDEF TNT}TTntPanel{$ELSE}TPanel{$ENDIF}.Create(Component);
    with FPanel do
      Begin
       Parent:=Component as TWinControl;
       Visible:=True;
      end;
    FImage := TExtImage.Create(Component);
    with FImage do
      Begin
       Parent:=Component as TWinControl;
       Visible:=True;
      end;
   end;
end;

destructor TExtPanelImage.Destroy;
begin
  inherited Destroy;
  FMemo .Destroy;
  FPanel.Destroy;
  FImage.Destroy;
end;

{ TExtImages }

procedure TExtImages.p_SetDirectory(const as_value: String);
begin
  if FDirectory <> as_value Then
    Begin
      FDirectory:=as_value;
    end;
end;

procedure TExtImages.AddFile(const as_SourceFile: String);
begin

end;

procedure TExtImages.Click;
begin
  if Assigned(OnClick) Then
    inherited Click
   Else
     if not ( csDesigning in ComponentState)
     and FClickEdit
      Then
        try
        finally
        end;
end;

procedure TExtImages.ClickDoEdit;
begin

end;

// Renaming
procedure TExtImages.RenameImage(const AOldPath, ANewPath: String; const AnOptionalPanelImage : TExtPanelImage);
begin

end;

// initing panel and images' columns
constructor TExtImages.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FShowErrors:=True;
  FClickEdit:=True;
  FImagesFormat := 16/9;
  FPanelWidth  := CST_DEFAULT_PANEL_WIDTH;
  FPanelHeight := CST_DEFAULT_PANEL_HEIGHT;
  CreateImagesMap;
  Caption := '';
end;

// Loads the images at executing
procedure TExtImages.Loaded;
begin
  inherited Loaded;
  if not ( csDesigning in ComponentState)
  and ( FDirectory > '' ) then
    AddDirectory ( IncludeTrailingBackslash(FDirectory), FSubDirs );
end;

// Get the Index of Image in Collection
function TExtImages.IndexOf(const AValue: String): Integer;
var i : Integer;
begin
  Result:=-1;
  for i := 0 to FImagesColumns.Count - 1 do
   if AValue = FImagesColumns [ i ].Value Then
    Begin
      Result := i ;
    end;
end;

// Get the ImageIndex of Image
function TExtImages.ImageIndexOf(const AValue: String): Integer;
begin
  Result := IndexOf(AValue);
  if Result >= 0 Then
    Result:=Columns [ Result ].ImageIndex;
end;

procedure TExtImages.CreateResume(const As_PathOfImage, As_Resume: String);
begin
end;

procedure TExtImages.CreateImagesMap;
begin
  FImagesColumns := TExtCollectionImages.Create(Self,TExtPanelImage);
  // adding editing component
  FImagesColumns.Add;
end;

procedure TExtImages.SetColumns(AValue: TExtCollectionImages);
begin
  FImagesColumns.Assign(AValue);
end;

procedure TExtImages.AddDirectory(const as_Directory: String; ab_SubDirs : Boolean );
var lstl_Files : TStringList;
    li_i : Integer;
begin
  try
      if fb_FindFiles ( lstl_Files, As_Directory, True, True, True, '*' ) Then
        for li_i := 0 to lstl_Files.count-1 do
         if DirectoryExistsUTF8 ( As_Directory + lstl_Files [ li_i ] ) Then
          AddDirectory ( As_Directory + lstl_Files [ li_i ], ab_SubDirs )
         Else
          AddFile(As_Directory + lstl_Files [ li_i ]);
  finally
  end;
end;


{$IFDEF VERSIONS}
initialization
  p_ConcatVersion ( gVer_TExtImages );
{$ENDIF}
end.
